<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="区域名称" name="zoneName">
						<a-input v-model:value="searchFormState.zoneName" placeholder="请输入区域名称"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="粮食种类" name="grainGroup">
						<a-select v-model:value="searchFormState.grainGroup" placeholder="请选择粮食种类" :options="grainGroupOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotZonePriceAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						新增
					</a-button>
					<a-button type="primary" @click="exportTable()"><export-outlined/>导出</a-button>
					<a-button danger @click="deleteBatchDepotZonePrice()" v-if="hasPerm('depotZonePriceBatchDelete')">删除</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'grainGroup'">
					{{ $TOOL.dictTypeData('粮食种类', record.grainGroup) }}
				</template>
				<template v-if="column.dataIndex === 'action'">
					<a-space>
						<a @click="formRef.onOpen(record)" v-if="hasPerm('depotZonePriceEdit')">编辑</a>
						<a-divider type="vertical" v-if="hasPerm(['depotZonePriceEdit', 'depotZonePriceDelete'], 'and')"/>
						<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotZonePrice(record)">
							<a-button type="link" danger size="small" v-if="hasPerm('depotZonePriceDelete')">删除</a-button>
						</a-popconfirm>
					</a-space>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
</template>

<script setup name="depotZonePrice">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import depotZonePriceApi from '@/api/biz/depotZonePriceApi'
import * as XLSX from "xlsx";
import moment from "moment";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const columns = [
	{
		title: '区域名称',
		dataIndex: 'zoneName'
	},
	{
		title: '价格(元/吨)',
		dataIndex: 'zonePrice'
	},
	{
		title: '粮食种类',
		dataIndex: 'grainGroup'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['depotZonePriceEdit', 'depotZonePriceDelete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
let loadDataLst
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotZonePriceApi.depotZonePricePage(Object.assign(parameter, searchFormParam)).then((data) => {
		loadDataLst = data.records
		return data
	})
}
// 删除
const deleteDepotZonePrice = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotZonePriceApi.depotZonePriceDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotZonePrice = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotZonePriceApi.depotZonePriceDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
// 导出
const exportTable = () => {
	let tableData = [['区域', '区域价格(元/吨)', '粮食种类', '创建时间']]
	let idStr = ''
	if (selectedRowKeys.value.length > 0) {
		selectedRowKeys.value.map((m) => {
			idStr = idStr + ',' + m
		})
	}
	loadDataLst.map((m) => {
		if (!idStr || idStr.indexOf(m.id) > 0)
			tableData.push([m.zoneName, m.zonePrice, m.grainGroup, m.createTime])
	})
	let workSheet = XLSX.utils.aoa_to_sheet(tableData)
	let bookNew = XLSX.utils.book_new()
	XLSX.utils.book_append_sheet(bookNew, workSheet, 'Sheet1')
	let name = '主流价格' + moment().format('_YYYY-MM-DD') + '.xlsx'
	XLSX.writeFile(bookNew, name)
}
const grainGroupOptions = tool.dictList('粮食种类')
</script>
